
// ================================
// 　マーカーの新着ポップアップと
// 　マーカー移動情報（ドラッグ＆ドロップ）
// ================================
var last_new_lat=0.0;
var last_new_lon=0.0;
var first_marker=true;
var last_new_datetime = '0000-00-00 00:00:00';
var marker_movable_flag = false;
var	marker_drag_start_lon;
var marker_drag_start_lat;

// ================================
//　右クリックメニューの準備
// ================================
var rmenu = document.createElement("div");
rmenu.style.visibility = "hidden";
rmenu.style.backgroundColor = "white";
rmenu.style.border = "2px solid #dcdcdc";
rmenu.style.padding = "2px";
rmenu.style.fontSize = "12px";
rmenu.style.cursor = "pointer";
rmenu.style.color = "#7176bf";   

// ================================
//　onLoad
// ================================
function onLoad() {
	
	var map = new GMap2(document.getElementById('map'));
	map.setCenter(new GLatLng(36.6124187943729, 136.7833685874939), 13);
	map.addControl(new GMapTypeControl());
	map.addControl(new GSmallZoomControl());

	//右クリックメニューをmapに登録
	map.getContainer().appendChild(rmenu);

	//マップ上での右クリックのイベントハンドラを登録
	//　→　マーカー修正メニューを表示する
	GEvent.addListener(map, "singlerightclick", function(point) {
		var rmenux = point.x;
		var rmenuy = point.y;
		var rmenu_pos = new GControlPosition(G_ANCHOR_TOP_LEFT, new GSize(rmenux, rmenuy));

		//右クリックメニューの内容(HTML）
		if(marker_movable_flag==false)
			rmenu.innerHTML = "<a href='javascript:setMarkerMovable(true);'>・マーカー位置修正モードに切替える</a><br />" ;
		else
			rmenu.innerHTML = "<a href='javascript:setMarkerMovable(false);'>・マーカー位置修正モードから抜ける</a><br />" ;
		rmenu_pos.apply(rmenu);
		rmenu.style.visibility = "visible";
	});

	//マップ上でのクリックのイベントハンドラを登録
	GEvent.addListener(map, "click", function() {
		// マーカー修正メニューを消す
		rmenu.style.visibility = "hidden";
	});

	//マップからフォーカスが外れた時のイベントハンドラを登録
	GEvent.addListener(map, "mouseout", function() {
		// マーカー修正メニューを消す
		rmenu.style.visibility = "hidden";
	});

	// SQLサーバに登録されているマーカーデータをJSONで要求
	sendRequest(on_loaded, '', 'GET', './mapcast_get_ListJSON.php', true, true);

	// ------------------------------
	//　JSONデータ取得完了のコールバック
	// ------------------------------
	function on_loaded(oj) {
		// JSONデータをevalでメモリ上に展開
		eval('var res = ' + decodeURIComponent(oj.responseText) );

		// 最新のマーカーをチェック
		if(last_new_datetime == res.marker[0].registtime) {
			// 新しいマーカーは無い
		}
		else {
			// 新しいマーカーが増えていた場合
			last_new_lat = res.marker[0].lat;
			last_new_lon = res.marker[0].lon;
			last_new_datetime = res.marker[0].registtime;
			var counts = 1;
			if(first_marker) {
				first_marker=false;
				map.clearOverlays();
				map.setCenter(new GLatLng(last_new_lat, last_new_lon), 13);
				counts = res.listCount;
			}

			// マーカーの数だけ繰り返す
			for(var i=0; i <  counts; i++) {
				// マーカーの吹き出しに使うHTMLを作成
				var point = new GLatLng(res.marker[i].lat, res.marker[i].lon);
				heading = res.marker[i].heading;
				registtime = res.marker[i].registtime;
				filename = res.marker[i].filename;
				phoneid = res.marker[i].phoneid;
				freecomment = res.marker[i].freecomment;
				freecomment = decodeURI(freecomment);
				iconname = res.marker[i].icon;
				tmpHTML = "<![CDATA[ <b>日時：　 " + registtime + "<br></b>方角：　 " + heading + "<br><a href='photo/" + filename + "' target=_blank><img src='photo/" + filename + "' height=150/></a><br />メモ： " + freecomment + "<br />  ";
				marker = createMarker2(point, tmpHTML,'title', iconname, phoneid, registtime);

				// 新しく増えたマーカーの場合には、吹き出しを表示する
				if(counts ==1)
					map.openInfoWindowHtml(point, tmpHTML);
			}
			// 最新のマーカーを地図の中心に表示
			var c_point = new GLatLng(res.marker[0].lat, res.marker[0].lon);
			map.panTo(c_point);
		}

		// タイマーで定期的に情報の更新をチェック
		window.setTimeout(
			function() {
				sendRequest(on_loaded, '', 'GET', './mapcast_get_ListJSON.php', true,true);
			},
			5000
		);

		// -------------------
		//　マーカー生成
		// -------------------
		function createMarker2(point, html, title, iconname, phoneid, registtime) {
			var icon = new GIcon();
			var marker = new GMarker(point, {draggable: true, autoPan: true});
	
			//マーカードラッグ開始のイベントハンドラを登録
			GEvent.addListener(marker,'dragstart', function() {
				//ドラッグ開始位置をメモ
				marker_drag_start_lon = marker.getPoint().lng();
				marker_drag_start_lat = marker.getPoint().lat();
				}
			);

			//マーカードラッグ終了のイベントハンドラを登録
			GEvent.addListener(marker,'dragend', function() {
				// マーカー位置修正モードでない場合、マーカーを元の位置にもどす
				if(marker_movable_flag==false)
					{
					marker.setPoint( new GLatLng(marker_drag_start_lat , marker_drag_start_lon) );
					map.panTo(marker.getPoint());
					return;
					}

				// マーカーをドロップした位置を画面中央にパン
				map.panTo(marker.getPoint());

				// ドロップ位置を新たなマーカー位置としてSQLサーバに更新登録
				sendRequest(on_loaded1, '&phoneid='+phoneid+'&registtime='+registtime+'&lon='+marker.getPoint().lng()+'&lat='+marker.getPoint().lat(), 'GET', './update_marker_lonlat.php', true,true);

				// SQL登録後のコールバック
				function on_loaded1(oj){
					var res=decodeURIComponent(oj.respoinseText);
					// SQL更新のエラー処理、情報表示などをここで行う
				}
			});

			// マーカーがクリックされた時のイベントハンドラを登録
			GEvent.addListener(marker, "click", function() {
				marker.openInfoWindowHtml(html);
			});

			// マーカーをマップに追加
			map.addOverlay(marker);
			return marker;

		}	// end - createMaker2
	}	// end - on_loaded
}	// end - onLoad

// ================================
//　マーカー修正モードへの切り替え
// ================================
function setMarkerMovable(flag)
{
	rmenu.style.visibility = "hidden";
	if(flag == true)
		marker_movable_flag=true;
	else
		marker_movable_flag=false;
}	// end - setMarkerMovable

