//
//  FlipsideViewController.h
//  MapCast
//
//  Created by Yos Hashimoto.
//  Copyright Newton Japan Inc. 2009. All rights reserved.
//

#import "AppData.h"

@protocol FlipsideViewControllerDelegate;


@interface FlipsideViewController : UIViewController {
	id <FlipsideViewControllerDelegate> delegate;
	
	AppData		*appData;
	IBOutlet	UITextView	*textView;
	IBOutlet	UIImageView	*imageView;
}

@property (nonatomic, assign) id <FlipsideViewControllerDelegate> delegate;

@property (nonatomic, retain) AppData		*appData;
@property (nonatomic, retain) IBOutlet	UITextView	*textView;
@property (nonatomic, retain) IBOutlet	UIImageView	*imageView;

- (IBAction)done;
- (IBAction)send;
- (void) sendImage:(UIImage*)imageToSend andText:(NSString*)comment;

@end


@protocol FlipsideViewControllerDelegate
- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller;
@end

