//
//  DetailViewController.m
//  MusicRank
//
//  Created by Yos Hashimoto.
//  Copyright 2009 Newton Japan Inc.. All rights reserved.
//

#import "DetailViewController.h"
#import "Music.h"

@implementation DetailViewController

@synthesize aMusic;

#pragma mark -
#pragma mark Object lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
	
	self.title = @"";
}

- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	
	self.title = aMusic.name;
	[tableView reloadData];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}


#pragma mark -
#pragma mark TableView

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 4;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tv cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"ReuseCellID";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }
	
	switch(indexPath.section)
	{
		case 0:
			cell.text = aMusic.artist;
			break;
		case 1:
			cell.text = aMusic.rights;
			break;
		case 2:
			cell.text = [aMusic.releaseDate substringWithRange:NSMakeRange(0,10)];
			break;
		case 3:
			cell.text = aMusic.price;
			break;
	}
	
	return cell;
}

- (NSString *)tableView:(UITableView *)tblView titleForHeaderInSection:(NSInteger)section {
	
	NSString *sectionName = nil;
	
	switch(section)
	{
		case 0:
			sectionName = [NSString stringWithString:@"アーティスト"];
			break;
		case 1:
			sectionName = [NSString stringWithString:@"コピーライト"];
			break;
		case 2:
			sectionName = [NSString stringWithString:@"リリース日付"];
			break;
		case 3:
			sectionName = [NSString stringWithString:@"価格"];
			break;
	}
	
	return sectionName;
}



- (void)dealloc {
    [super dealloc];
}


@end
