//
//  Music.m
//  MusicRank
//
//  Created by Yos Hashimoto.
//  Copyright 2009 Newton Japan Inc.. All rights reserved.
//

#import <objc/objc.h>
#import <objc/runtime.h>
#import "Music.h"

#define kPrefix	@"im:"

@implementation Music
@synthesize musicID, name, artist, rights, price, releaseDate, propertyDic;

#pragma mark -
#pragma mark Application lifecycle

// インスタンスを初期化する
-(id)init {
	propertyDic = [[NSMutableDictionary alloc] initWithDictionary:[self makePropertyDictionary]];
	return self;
}

- (void) dealloc {
	
	[price release];
	[rights release];
	[artist release];
	[name release];
	[musicID release];
	[super dealloc];
}

#pragma mark -
#pragma mark Property handling

// クラスのプロパティ名称の一覧辞書を作成する
-(NSMutableDictionary *)makePropertyDictionary {     
	unsigned int outCount;
	
	objc_property_t *propList = class_copyPropertyList([self class], &outCount);
	NSMutableDictionary *properties = [[NSMutableDictionary alloc] initWithCapacity:outCount];
	
	int i;
	for (i=0; i < outCount; i++) {
		objc_property_t* aProp = propList + i;
		NSString *propName = [[NSString alloc] initWithCString:property_getName(*aProp)];
		[properties setValue:propName forKey:propName];
		[properties setValue:propName forKey:[NSString stringWithFormat:@"%@%@", kPrefix, propName]];
		[propName release];
	}
	
	[properties autorelease];	// オブジェクトの解放に注意！
	return properties;
}

// RSSのエレメントに対応するインスタンスプロパティ名を得る
-(NSString*)getPropertyNameFor:(NSString*)elementName {
	
	NSString* propName = [propertyDic objectForKey:elementName];
	return propName;
}

@end
